#[doc = "Register `A02` reader"]
pub struct R(crate::R<A02_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<A02_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<A02_SPEC>> for R {
    fn from(reader: crate::R<A02_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `A02` writer"]
pub struct W(crate::W<A02_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<A02_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<A02_SPEC>> for W {
    fn from(writer: crate::W<A02_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `A0_0` reader - Accumulator 0 for UDB\\[n\\]"]
pub struct A0_0_R(crate::FieldReader<u8, u8>);
impl A0_0_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0_0` writer - Accumulator 0 for UDB\\[n\\]"]
pub struct A0_0_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
        self.w
    }
}
#[doc = "Field `A0_1` reader - Accumulator 0 for UDB\\[n+1\\]"]
pub struct A0_1_R(crate::FieldReader<u8, u8>);
impl A0_1_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0_1` writer - Accumulator 0 for UDB\\[n+1\\]"]
pub struct A0_1_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | ((value as u32 & 0xff) << 8);
        self.w
    }
}
#[doc = "Field `A0_2` reader - Accumulator 0 for UDB\\[n+2\\]"]
pub struct A0_2_R(crate::FieldReader<u8, u8>);
impl A0_2_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0_2` writer - Accumulator 0 for UDB\\[n+2\\]"]
pub struct A0_2_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | ((value as u32 & 0xff) << 16);
        self.w
    }
}
#[doc = "Field `A0_3` reader - Accumulator 0 for UDB\\[n+3\\]"]
pub struct A0_3_R(crate::FieldReader<u8, u8>);
impl A0_3_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_3_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0_3` writer - Accumulator 0 for UDB\\[n+3\\]"]
pub struct A0_3_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_3_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 24)) | ((value as u32 & 0xff) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Accumulator 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn a0_0(&self) -> A0_0_R {
        A0_0_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Accumulator 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn a0_1(&self) -> A0_1_R {
        A0_1_R::new(((self.bits >> 8) & 0xff) as u8)
    }
    #[doc = "Bits 16:23 - Accumulator 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn a0_2(&self) -> A0_2_R {
        A0_2_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:31 - Accumulator 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn a0_3(&self) -> A0_3_R {
        A0_3_R::new(((self.bits >> 24) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Accumulator 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn a0_0(&mut self) -> A0_0_W {
        A0_0_W { w: self }
    }
    #[doc = "Bits 8:15 - Accumulator 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn a0_1(&mut self) -> A0_1_W {
        A0_1_W { w: self }
    }
    #[doc = "Bits 16:23 - Accumulator 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn a0_2(&mut self) -> A0_2_W {
        A0_2_W { w: self }
    }
    #[doc = "Bits 24:31 - Accumulator 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn a0_3(&mut self) -> A0_3_W {
        A0_3_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Accumulator 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [a02](index.html) module"]
pub struct A02_SPEC;
impl crate::RegisterSpec for A02_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [a02::R](R) reader structure"]
impl crate::Readable for A02_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [a02::W](W) writer structure"]
impl crate::Writable for A02_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets A02 to value 0"]
impl crate::Resettable for A02_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
